/*
  SFDatabase-js
  SFDatabase-js is a database library that can help you
  build a SQL Query and execute it to the server from
  Nodejs or local browser with WebSQL.

  https://github.com/ScarletsFiction/SFDatabase-js
*/
"use strict";function asyncGeneratorStep(e,r,n,t,o,i,u){try{var s=e[i](u),a=s.value}catch(e){return void n(e)}s.done?r(a):Promise.resolve(a).then(t,o)}function _asyncToGenerator(e){return function(){var r=this,n=arguments;return new Promise((function(t,o){var i=e.apply(r,n);function u(e){asyncGeneratorStep(i,t,o,u,s,"next",e)}function s(e){asyncGeneratorStep(i,t,o,u,s,"throw",e)}u(void 0)}))}}function SFDatabase(e,r){var n=this;let t;n.db=null,n.busy=new Promise((e=>t=e)),n.onError=r.onError,n.initialized=!1;let o=r.onInit;r||(r={debug:!1});var i=function(){function e(){t();for(let e=0;e<s.length;e++)s[e]();s=null,u()}n.initialized||(n.initialized=!0,o?setTimeout((function(){o(),e()}),1):e())};let u,s=[];n.onInit=function(e){if(n.initialized)return e();s.push(e)},n.waitInit=new Promise((e=>u=e));var a=function(e){if(e&&"object"==typeof e){if(e.constructor===Array)e.splice(0);else for(var r=Object.keys(e),n=0;n<r.length;n++)delete e[r[n]];e=null}};n.preprocessTable=r.preprocessTable||{};var c=function(e,r,t,o=!1){var i=!1;if(!n.preprocessTable[e])return i;for(var u=Object.keys(n.preprocessTable[e]),s=0;s<u.length;s++)t[u[s]]&&n.preprocessTable[e][u[s]][r]&&(t[u[s]]=n.preprocessTable[e][u[s]][r](t[u[s]],o),i=!0);return i},l=null,f=function(){var e=_asyncToGenerator((function*(e){let t=r.structure;l&&(l(),l=null),n._restructuring=!0;try{for(var o in t)yield n.createTable(o,t[o])}catch(e){throw console.error(e),e}n._restructuring=!1,e?e():i()}));return function(r){return e.apply(this,arguments)}}();function d(){function e(e){return"`"+e.match(/[a-zA-Z0-9_\.]+/i)[0]+"`"}function r(e){let r={};return t(r,e),r}function t(e,r){for(var n in r)"object"!=typeof r[n]?e[n]=r[n]:(r[n]instanceof Array?e[n]=[]:e[n]={},t(e[n],r[n]))}var o=[">",">=","<","<="],i=["*","-","/","%","+"];n.makeWhere=function(r,t,i){if(!r)return["",[]];for(var u=[],s=[],a=Object.keys(r),c=" AND ",l=["order","limit"],f=0;f<a.length;f++){let n=a[f];var d=r[n],p=n.match(/([a-z0-9_\.]+)(\[(\>\=?|\<\=?|\!|\<\>|\>\<|\!?~|\!?&~|\!?,|\!?&,|REGEXP|LENGTH)\])?/i),h=p[1],y=p[1].toLowerCase();if("and"===y||"or"===y)continue;if(!i&&l.includes(y))continue;h=e(h);let t=p[3];if(t){if(o.includes(t)){if(!isNaN(d)){u.push(h+" "+t+" ?"),s.push(d);continue}var v="SQL where: value of "+h+" is non-numeric and can't be accepted";console.error(v)}else if("!"===t){var b;if(b=null!=d&&d.constructor)if(b===Array){for(var w=[],g=0;g<d.length;g++)w.push("?");u.push(h+" NOT IN ("+w.join(",")+")"),s=s.concat(d)}else b===Number||b===Boolean||b===String?(u.push(h+" != ?"),s.push(d)):console.error("SQL where: value "+h+" with type "+b.name+" can't be accepted");else u.push(h+" IS NOT NULL")}else if(t.endsWith("~")){d.constructor!==Array&&(d=[d]);var T=t.includes("&")?" AND ":" OR ",I=t.includes("!")?" NOT":"",E=[];for(g=0;g<d.length;g++)E.push(h+I+" LIKE ?"),!1===d[g].includes("%")&&(d[g]="%"+d[g]+"%"),s.push(d[g]);u.push("("+E.join(T)+")")}else if(t.endsWith(",")){T=t.includes("&")?" AND ":" OR ",I=t.includes("!")?" NOT":"";if(d.constructor!==Array)if(d.length>2&&" OR "===T){var m;m=""!==I&&"pgsql"===driver?" !~ ?":" NOT REGEXP ?",u.push(h+m),s.push(",("+d.join("|")+"),")}else{var D=[];for(g=0;g<d.length;g++)D.push(h+I+" LIKE ?"),s.push("%,"+d[g]+",%");u.push(D.join(T))}else{if(" AND "===T)throw new Error(`SQL where: value of ${validatedColumn} must be a array`);u.push(validatedColumn+I+" LIKE ?"),s.push("%,"+d+",%")}}else if(t=t.toUpperCase(),t.includes("LENGTH")){var S=t.split("(");if(1===S.length)S="=";else if(S=S[0].replace(")",""),!1===o.includes(S)&&"!="!==S)throw new Error("SQL where: operation $op is not recognized");u.push("CHAR_LENGTH("+e(p[0])+") "+S+" ?"),s.push(d)}else if("REGEXP"===t){if(d.constructor===Array)throw new Error("SQL where: value of"+e($matches[0])+" must be a string");u.push(e(p[0])+("pgsql"===driver?" ~ ":" REGEXP ")+"?"),s.push(d)}}else if(b=null!=d&&d.constructor)if(b===Array){for(w=[],g=0;g<d.length;g++)w.push("?");u.push(h+" IN ("+w.join(",")+")"),s=s.concat(d)}else b===Number||b===Boolean||b===String?(u.push(h+" = ?"),s.push(d)):console.error("SQL where: value "+h+" with type "+b.name+" can't be accepted");else u.push(h+" IS NULL")}for(f=0;f<a.length;f++){let e=a[f];if("ORDER"!==e&&"LIMIT"!==e){var R=e.split("AND"),L=!1;if(2===R.length&&""===R[0]?(c=" AND ",L=!0):2===(R=e.split("OR")).length&&""===R[0]&&(c=" OR ",L=!0),L){var O=n.makeWhere(r[e],c,!0);u.push("("+O[0]+")"),s=s.concat(O[1])}}}var A="";if(r.ORDER){let n=r.ORDER;var N=[];for(let t in n){var $=r.ORDER[n].toUpperCase();"ASC"!==$&&"DESC"!==$||N.push(e(n)+" "+$)}A=A+" ORDER BY "+N.join(",")}r.LIMIT&&(isNaN(r.LIMIT[0])||isNaN(r.LIMIT[1])?isNaN(r.LIMIT)||(A=A+" LIMIT "+r.LIMIT):A=A+" LIMIT "+r.LIMIT[1]+" OFFSET "+r.LIMIT[0]);var j="";return 0!==u.length&&(i||(j=" WHERE "),j+=u.join(t||c)),[j+A,s]},n.createTable=function(){var r=_asyncToGenerator((function*(r,t){for(var o=Object.keys(t),i=0;i<o.length;i++)t[o[i]].constructor===Array?o[i]=e(o[i])+" "+t[o[i]].join(" ").toUpperCase():o[i]=e(o[i])+" "+String(t[o[i]]).toUpperCase();var u="CREATE TABLE IF NOT EXISTS "+e(r)+" ("+o.join(",")+")";return yield n.SQLQuery(u,[])}));return function(e,n){return r.apply(this,arguments)}}(),n.select=function(){var r=_asyncToGenerator((function*(r,t,o){var i=t;if("*"!==t){t.constructor===String&&(i=[e(t)]);for(var u=0;u<i.length;u++)i[u]=e(i[u])}else i=!1;var s=n.makeWhere(o),a="SELECT "+(i?i.join(","):t)+" FROM "+e(r)+s[0];let l=yield n.SQLQuery(a,s[1],!0);if(0!==l.length&&c(r,"get",l[0]))for(u=1;u<l.length;u++)c(r,"get",l[u]);return l}));return function(e,n,t){return r.apply(this,arguments)}}(),n.has=function(){var r=_asyncToGenerator((function*(r,t){t.LIMIT=1;var o=n.makeWhere(t),i="SELECT 1 FROM "+e(r)+o[0];return 0!==(yield n.SQLQuery(i,o[1],!0)).length}));return function(e,n){return r.apply(this,arguments)}}(),n.get=function(){var e=_asyncToGenerator((function*(e,r,t){t.LIMIT=1;let o=yield n.select(e,r,t);return 0===o.length?null:r.constructor===Array?o[0]:o[0][r]}));return function(r,n,t){return e.apply(this,arguments)}}(),n.delete=function(){var r=_asyncToGenerator((function*(r,t){if(t){var o=n.makeWhere(t),i="DELETE FROM "+e(r)+o[0];return yield n.SQLQuery(i,o[1])}i="TRUNCATE TABLE "+e(r);try{return yield n.SQLQuery(i,[])}catch(e){e.message.includes("syntax error")&&n.delete(r,[])}}));return function(e,n){return r.apply(this,arguments)}}(),n.insert=function(){var t=_asyncToGenerator((function*(t,o){var i=[],u=[],s=[],a=r(o);c(t,"set",a);for(let r in o)i.push(e(r)),u.push("?"),s.push(a[r]);var l="INSERT INTO "+e(t)+" ("+i.join(",")+") VALUES ("+u.join(",")+")";return yield n.SQLQuery(l,s)}));return function(e,r){return t.apply(this,arguments)}}(),n.update=function(){var t=_asyncToGenerator((function*(t,o,u){var s=n.makeWhere(u),a=[],l=[],f=r(o);c(t,"set",f,!0);var d,p=n._isSQLite;for(let r in o){var h=!1===(d=(d=r).split("#")[0].trim()).includes("[")?[d]:d.replace(/[\]"'`]/g,"").split("["),y=e(h[0]),v=o[r];if(1===h.length)a.push(`${y} = ?`);else{if(",++"===h[1]){p?a.push(`${y} = ${y} || ?`):a.push(`${y} = CONCAT(${y}, ?)`),v.constructor===Array?l.push(v.join(",")+","):l.push(v+",");continue}if(",--"===h[1]){v.constructor===Array?(a.push(`${y} = REGEXP_REPLACE(${y}, ?, ',')`),l.push(",("+v.join("|")+"),")):(a.push(`${y} = REPLACE(${y}, ?, ',')`),l.push(","+v+","));continue}if(v.constructor===String)if("append"===h[1])p?a.push(`${y} = ${y} || ?`):a.push(`${y} = CONCAT(${y}, ?)`);else{if("prepend"!==h[1])throw new Error(`No operation for '${h[1]}'`);p?a.push(`${y} = ? || ${y}`):a.push(`${y} = CONCAT(?, ${y})`)}else{if(v.constructor===Array){if("replace"===h[1])a.push(`${y} = REPLACE(${y}, ?, ?)`);else{if("wrap"!==h[1])throw new Error(`No operation for '${h[1]}'`);p?a.push(`${y} = ? || ${y} || ?`):a.push(`${y} = CONCAT(?, ${y}, ?)`)}l.push(v[0]),l.push(v[1]);continue}if(!i.includes(h[1]))throw new Error(`No operation for '${h[1]}'`);a.push(`${y} = ${y} ${h[1]} ?`)}}l.push(f[r])}var b="UPDATE "+e(t)+" SET "+a.join(",")+s[0];return yield n.SQLQuery(b,l.concat(s[1]))}));return function(e,r,n){return t.apply(this,arguments)}}(),n.drop=function(){var r=_asyncToGenerator((function*(r){return yield n.SQLQuery("DROP TABLE "+e(r),[])}));return function(e){return r.apply(this,arguments)}}(),n.closeDatabase=function(){if(!n.polyfill)return new Promise((function(e,r){n.db.close(e,(function(e){r("Error closing Database:"+e.message)}))}))}}if(!isNode&&null!=r.idbVersion){var p=function(e){console.error(e.target&&e.target.error.message||e)};h((function(e){if("function"!=typeof IDBOpenDBRequest)return console.warn("Fallback to WebSQL",e),y();p(e)}))}function h(t){function o(e){n.db.result&&(n.db=n.db.result),n.busy=new Promise((e=>{f((function(){n.busy&&(n.busy=!1,e())}))}))}!function(){let e={};var t=function r(n,t,o){var u=!o;for(let w in t){var s,a=null!==(s=e[w])&&void 0!==s?s:e[w]=w.match(/([a-zA-Z0-9_\.]+)(\[(\>\=?|\<\=?|\!|\<\>|\>\<|\!?~)\])?/),c=a[1].toLowerCase();if("AND"!==c&&"OR"!==c){var l=t[w],f=!0;if("AND"===a[1])f=r(n,t[w],!1);else if("OR"===a[1])f=r(n,t[w],!0);else if(void 0===a[3])l.constructor===Array?!1===l.includes(n[a[1]])&&(f=!1):n[a[1]]!=l&&(f=!1);else if("!"===a[3])l.constructor===Array?l.includes(n[a[1]])&&(f=!1):n[a[1]]==l&&(f=!1);else if(">"===a[3])n[a[1]]<=l&&(f=!1);else if(">="===a[3])n[a[1]]<l&&(f=!1);else if("<"===a[3])n[a[1]]>=l&&(f=!1);else if("<="===a[3])n[a[1]]>l&&(f=!1);else if("><"===a[3])(n[a[1]]<=l[0]||n[a[1]]>=l[1])&&(f=!1);else if("=><="===a[3])(n[a[1]]<l[0]||n[a[1]]>l[1])&&(f=!1);else if("<>"===a[3])(n[a[1]]>=l[0]||n[a[1]]<=l[1])&&(f=!1);else if("<=>"===a[3])(n[a[1]]>l[0]||n[a[1]]<l[1])&&(f=!1);else if(a[3].includes("~")){for(var d=1,p=[],h=l.constructor===Array?l:[l],y=0;y<h.length;y++){var v=h[y];"%"===v.slice(0,1)&&"%"===v.slice(-1)?(d=1,v=v.slice(1,-1)):"%"===v.slice(0,1)?(d=2,v=v.slice(1)):"%"===v.slice(-1)&&(d=3,v=v.slice(0,-1)),v=v.replace(i,"\\$&"),2===d?v+="$":3===d&&(v="^"+v),p.push(v)}var b=n[a[1]].match(RegExp(p.join("|"),"i"));a[3].includes("!")?b&&(f=!1):b||(f=!1)}if(o)u=u||f;else if(!f){u=!1;break}}}return u},o=r.structure,i=/[-\/\\^$*+?.()|[\]{}]/g,u=function(e){return e.found++,e.processed++,e.found>e.startFrom?e.processed<=e.limit?1:-1:0};function s(e,r,n){var t=o[e],i=void 0,u=null;if(n.constructor!==String&&(i=n,n=void 0),t)for(let e in r){let o=e.split("[");if(null!=t[o[0]]&&(void 0===n||null!=n&&o[0]===n)){u=c(o,r[e]);break}}if(null!=i){if(null!==u)try{return i.index(key).openCursor(u)}catch(e){return i.openCursor()}return i.openCursor()}return u}var a=function(){var e=_asyncToGenerator((function*(e,r,t){return new Promise(((i,u)=>{var a=n.getObjectStore(e,r,(function(e){u(e.target?e.target.error:e)}));if(!a)return u("Internal error");var c={found:0,processed:0};if(null!=t.LIMIT?"number"==typeof t.LIMIT?(c.startFrom=0,c.limit=t.LIMIT):(c.startFrom=t.LIMIT[0],c.limit=t.LIMIT[1]):c.limit=!1,delete t.LIMIT,null!=t.ORDER){var l=t.ORDER;delete t.ORDER;var f=null;if("string"==typeof l)null==o[e]&&null==o[e][l]||(f=s(e,t,l)),c.request=a.index(l).openCursor(f,"next");else{var d=Object.keys(l)[0];null==o[e]&&null==o[e][d]||(f=s(e,t,d)),"ASC"===l[d]&&(c.request=a.index(d).openCursor(f,"next")),"DESC"===l[d]&&(c.request=a.index(d).openCursor(f,"prev"))}}else c.request=s(e,t,a);i(c)}))}));return function(r,n,t){return e.apply(this,arguments)}}();function c(e,r){if(r.constructor===String){if(0===r.length)return null;r=r.slice(0,1)}return r.constructor===Array&&r[0].constructor===String&&(r=[r[0],r[1]]),2===e.length?">]"===(e=e[1])?IDBKeyRange.upperBound(r):">=]"===e?IDBKeyRange.upperBound(r,!0):"<]"===e?IDBKeyRange.lowerBound(r):"<=]"===e?IDBKeyRange.lowerBound(r,!0):"><]"===e?IDBKeyRange.bound(r[0],r[1]):">=<]"===e?IDBKeyRange.bound(r[0],r[1],!0):null:IDBKeyRange.only(r)}n.createTable=function(){var e=_asyncToGenerator((function*(e,r){if(!n._restructuring)throw new Error("`createTable` is unavailable because the database version need to be changed. Try changing the database structure on first initialization, and increment the version.");if(!n.db.objectStoreNames.contains(e)){var t,o=n.db.createObjectStore(e,{keyPath:"rowid",autoIncrement:!0});for(let e in r){var i;if("$"!==e.slice(0,1))continue;let n="string"!=typeof(t=e)?t:t.match(/[a-zA-Z0-9_\.]+/)[0]||"",u=r[e];o.createIndex(n,n,{unique:null!==(i=u.unique)&&void 0!==i&&i})}}}));return function(r,n){return e.apply(this,arguments)}}(),n.insert=function(){var e=_asyncToGenerator((function*(e,r){return yield n.busy,yield new Promise(((t,o)=>{var i=!1,u=n.getObjectStore(e,"readwrite",(function(){i||o(`"${e}" table was not found`)}));if(!u)return o("Failed to retrieve objectStore for: "+e);var s=u.add(r);s.onerror=function(){i=!0,o(`"${e}": duplicate on unique columns`)},s.onsuccess=function(e){t(e.target.result)}}))}));return function(r,n){return e.apply(this,arguments)}}(),n.bulkInsert=function(){var e=_asyncToGenerator((function*(e,r){return yield n.busy,yield new Promise(((t,o)=>{var i=!1,u=n.prepareTransaction(e,"readwrite",(function(){i||o(`"${e}" table was not found`)}));if(!u)return o("Failed to retrieve transaction for: "+e);let s=u.objectStore(e);for(let n=0;n<r.length;n++)s.add(r[n]).onerror=function(){i=!0,console.error(`"${e}": duplicate on unique columns`)};u.oncomplete=()=>t()}))}));return function(r,n){return e.apply(this,arguments)}}(),n.has=function(){var e=_asyncToGenerator((function*(e,r){return yield n.busy,yield new Promise(function(){var n=_asyncToGenerator((function*(n,o){var i=(yield a(e,"readonly",r,o)).request;i.onerror=o,i.onsuccess=function(){var e=i.result;if(e){if(t(e.value,r))return n(!0);e.continue()}else n(!1)}}));return function(e,r){return n.apply(this,arguments)}}())}));return function(r,n){return e.apply(this,arguments)}}(),n.cursor=function(){var e=_asyncToGenerator((function*(e,r,t,o){yield n.busy;var i=n.getObjectStore(e,r&&r.WRITE?"readwrite":"readonly",o);if(!i)throw new Error("Failed to retrieve object store for: "+e);if(r){var u="desc"===r.ORDER?"prev":"next";r.UNIQUE&&(u+="unique"),delete r.ORDER,delete r.UNIQUE;var s=Object.keys(r)[0],a=null;if(s){var l=s.split("[");i=i.index(l[0]),a=c(l,r[l])}var f=i.openCursor(a,u)}else f=i.openCursor();return f.onerror=o,f.onsuccess=t,f}));return function(r,n,t,o){return e.apply(this,arguments)}}(),n.get=function(){var e=_asyncToGenerator((function*(e,r,o){return yield n.busy,yield new Promise(function(){var n=_asyncToGenerator((function*(n,i){var u=(yield a(e,"readonly",o,i)).request;u.onerror=i,u.onsuccess=function(){var e=u.result;if(e){var i=e.value;if(t(i,o)){if("*"===r)return n(i);if(r.constructor===String)return n(i[r]);for(var s={},a=0;a<r.length;a++){let e=r[a];s[e]=i[e]}return n(s)}e.continue()}else n(null)}}));return function(e,r){return n.apply(this,arguments)}}())}));return function(r,n,t){return e.apply(this,arguments)}}(),n.select=function(){var e=_asyncToGenerator((function*(e,r,o){return yield n.busy,yield new Promise(function(){var n=_asyncToGenerator((function*(n,i){var s=yield a(e,"readonly",o,i),c=s.request;c.onerror=i,s.result=[];var l=function(e){if("*"!==r)if(r.constructor!==String){for(var n={},t=0;t<r.length;t++){let o=r[t];n[o]=e[o]}s.result.push(n)}else s.result.push(e[r]);else s.result.push(e)};c.onsuccess=function(){var e=c.result;if(e){var r=e.value;if(t(r,o))if(!1!==s.limit){var i=u(s);if(-1===i)return n(s.result);1===i&&l(r)}else l(r);e.continue()}else n(s.result)}}));return function(e,r){return n.apply(this,arguments)}}())}));return function(r,n,t){return e.apply(this,arguments)}}(),n.delete=function(){var e=_asyncToGenerator((function*(e,r){return yield n.busy,yield new Promise(function(){var o=_asyncToGenerator((function*(o,i){if(!r){var s=n.getObjectStore(e,"readwrite",i).clear();s.onsuccess=o,s.onerror=i}var c=yield a(e,"readwrite",r,i),l=c.request;l.onerror=i,l.onsuccess=function(){var e=l.result;if(e){var n=e.value;if(t(n,r))if(!1!==c.limit){var i=u(c);if(-1===i)return o(c.processed);1===i&&e.delete()}else c.processed++,e.delete();e.continue()}else o(c.processed)}}));return function(e,r){return o.apply(this,arguments)}}())}));return function(r,n){return e.apply(this,arguments)}}(),n.update=function(){var e=_asyncToGenerator((function*(e,r,o){return yield n.busy,yield new Promise(function(){var n=_asyncToGenerator((function*(n,i){var s=yield a(e,"readwrite",o,i),c=s.request,l=Object.keys(r),f=function(e,n){for(var t=0;t<l.length;t++){let e=l[t];n[e]=r[e]}e.update(n)};c.onerror=i,c.onsuccess=function(){var e=c.result;if(e){var r=e.value;if(t(r,o))if(!1!==s.limit){var i=u(s);if(-1===i)return n(s.processed);1===i&&f(e,r)}else s.processed++,f(e,r);e.continue()}else n(s.processed)}}));return function(e,r){return n.apply(this,arguments)}}())}));return function(r,n,t){return e.apply(this,arguments)}}(),n.drop=function(e){if(!n._restructuring)return console.warn("`drop` is unavailable because the database version need to be changed. Try changing the database structure on first initialization, and increment the version.");n.db.deleteObjectStore(e)},n.closeDatabase=function(){n.db.close()}}(),window.indexedDB||(window.indexedDB=window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB),window.IDBTransaction||(window.IDBTransaction=window.webkitIDBTransaction||window.msIDBTransaction),window.IDBKeyRange||(window.IDBKeyRange=window.webkitIDBKeyRange||window.msIDBKeyRange),window.indexedDB&&window.IDBTransaction&&window.IDBKeyRange?(n.storage="indexeddb",n.reopen=function(){l=function(){if(null!=r.idbVersion)for(var e=n.db.objectStoreNames,t=0;t<e.length;t++)void 0===r.structure[e[t]]&&n.drop(e[t]);l=null},n.db=window.indexedDB.open(e,r.idbVersion),n.db.onupgradeneeded=n.db.onversionchange=o,n.db.onsuccess=function(e){n.db.result&&(n.db=n.db.result),i()}},n.reopen(),n.prepareTransaction=function(e,r,t){try{var o=n.db.transaction(e,r)}catch(e){return void(t&&t(e))}return o.onerror=t||p,o},n.getObjectStore=function(e,r,t){return n.prepareTransaction(e,r,t).objectStore(e)}):t&&t("IndexedDB was not found")}function y(t){d(),n.SQLQuery=function(e,t){return new Promise((function(o,i){r.debug&&r.debug(e,t),n.db.transaction((function(r){r.executeSql(e,t,(function(r,n){a(t),t=e=null;var i=n&&n.rows?n.rows:n;if(n&&n.rowsAffected&&!i.length)return o(n.rowsAffected),void(i=null);if(i.length){for(var u=new Array(i.length),s=0;s<i.length;s++)u[s]=i[s];i=null,o(u)}else o([])}),(function(r,o){a(t),t=e=null,o&&n.onError&&n.onError(o),i("Database Error: "+o.message)}))}),(function(e){e&&n.onError&&n.onError(e),i("Database Transaction Error: "+e.message)}))}))},function r(o){!o&&window.sqlitePlugin?n.db=window.sqlitePlugin.openDatabase({name:e,location:"default"},f,(function(){console.error("Failed to initialize sqlitePlugin"),setTimeout((function(){r(!0)}),500)})):window.openDatabase?(n.db=window.openDatabase(e,"1.0",e,1024),n.db&&setTimeout(f,500)):(console.error("WebSQL is not supported on this browser"),t&&t())}()}null==r.idbVersion&&y((function(){console.warn("Fallback to IndexedDB"),h()}))}"undefined"!=typeof process&&process.execPath&&(module.exports=SFDatabase);
//# sourceMappingURL=sfdatabase.min.js.map
